import { FormRef, ValidationResult, MenuItem, ReducerActionHandler, UseStorageParams, FlattenedObject } from "../types/types";
import * as Yup from 'yup';
export declare const _isValidForm: (formRef: FormRef) => Promise<ValidationResult>;
export declare const _getStartStopTime: (sdate: Date, format?: string) => "Invalid Date" | {
    startTime: string;
    stopTime: string;
};
export declare const _isArrayEmpty: (value: unknown) => boolean;
export declare const _isObjectEmpty: (obj: object) => boolean;
export declare const _isValueInArray: <T>(array: T[], value: T) => boolean;
export declare const _exportToExcel: (jsonData: object[], fileName: string, fileExtension?: string) => void;
export declare const _promise: (time: number) => Promise<unknown>;
export declare const _hasItem: (menuItems: MenuItem[], path: string, key: string) => any | null;
export declare const _dynamicReducer: (initialState: any) => (state: any, action: any) => any;
export declare const _genericReducer: <State, Action extends {
    type: string;
}>(initialState: State, actions: Record<string, ReducerActionHandler<State, Action>>) => (state: State | undefined, action: Action) => State;
export declare const _thousandSeparator: (num: number) => {
    allDecimal: string;
    twoDecimal: string;
};
export declare const _getFinancialYear: () => string;
export declare const _getStorage: ({ action, type, key, value, }: UseStorageParams) => any | null;
export declare const _deepClone: <T>(obj: T) => T;
export declare const _getCookie: (name: string) => string | null;
export declare const _setCookie: (name: string, value: string, days: number) => void;
export declare const _mergeObjects: <T>(obj1: T, obj2: T) => T;
export declare const _mapObject: <T>(obj: {
    [key: string]: any;
}, callback: (key: string, value: any) => T) => T[];
export declare const _isEqual: <T>(value1: T, value2: T) => boolean;
export declare const _capitalize: (str: string) => string;
export declare const _convertToCurrency: (amount: number, currency?: string) => string;
export declare const _getBrowserInfo: () => string;
export declare const _isMobile: () => boolean;
export declare const _parseJSON: <T>(json: string) => T | null;
export declare const _scrollToTop: () => void;
export declare const _batchProcess: <T>(data: T[], batchSize: number, processFn: (item: T) => Promise<void>) => Promise<void>;
export declare const _flattenObject: (obj: any, prefix?: string) => FlattenedObject;
export declare const _deepMerge: (target: any, source: any) => any;
export declare const _chunk: <T>(arr: T[], size: number) => T[][];
export declare const _asyncDebounce: (fn: (...args: any[]) => Promise<void>, delay: number) => (...args: any[]) => Promise<void>;
export declare const _deepCloneArray: <T>(arr: T[]) => T[];
export declare const _getMaxMinValue: (arr: number[]) => {
    max: number;
    min: number;
};
export declare const _asyncMap: <T, U>(arr: T[], asyncFn: (item: T) => Promise<U>) => Promise<U[]>;
export declare const _transformAsyncData: <T, U>(arr: T[], transformer: (item: T) => Promise<U>) => Promise<U[]>;
export declare const _getNestedProperty: (obj: Record<string, any>, path: string) => Record<string, any>;
export declare const _deepEqual: (obj1: any, obj2: any) => boolean;
export declare const _mergeArrays: <T>(arr1: T[], arr2: T[]) => T[];
export declare const _filterDuplicates: <T>(arr: T[], uniqueKey: keyof T) => T[];
export declare const _sortByKey: <T>(arr: T[], key: keyof T) => T[];
export declare const _mapAsync: <T, U>(arr: T[], asyncFn: (item: T) => Promise<U>) => Promise<U[]>;
export declare const _formatDate: (date: Date, format: string) => string;
export declare const _calPercentage: (value: number, total: number) => number;
export declare const _sum: (numbers: number[]) => number;
export declare const _average: (numbers: number[]) => number;
export declare const _getPriceAfterTax: (price: number, taxRate: number) => number;
export declare const _calculateTimeDifference: (startDate: Date, endDate: Date) => string;
export declare const _arrayIncludesObject: (arr: any[], obj: any) => boolean;
export declare const _toCamelCase: (str: string) => string;
export declare const _arrayToObject: (arr: any[], key: string) => any;
export declare const _isInArray: (arr: any[], value: any) => boolean;
export declare const _getObjectValues: (obj: object) => any[];
export declare const _swapArrayElements: (arr: any[], index1: number, index2: number) => void;
export declare const _filterObjectByKey: (obj: object, keys: string[]) => {
    [k: string]: any;
};
export declare const _getScrollPosition: () => {
    scrollX: number;
    scrollY: number;
};
export declare const _arrayIntersection: (arr1: any[], arr2: any[]) => any[];
export declare const _getArrayOfObjectsByProperty: (arr: any[], key: string, value: any) => any[];
export declare const _downloadBlob: (blob: Blob, filename: string) => void;
export declare const _base64ToBlob: (base64: string) => Blob;
export declare const _initializeFormValues: (fields: string[]) => {
    [key: string]: any;
};
export declare const _dynamicRequiredValidation: (requiredFields: string[]) => Yup.ObjectSchema<any>;
export declare const _generateYupValidation: (fields: string[]) => Yup.ObjectSchema<any>;
export declare const _initializeFormikFields: (fields: string[]) => {
    [key: string]: string;
};
export declare const _setNestedProperty: (obj: any, path: string, value: any) => any;
export declare const _transformArray: <T, R>(arr: T[], transformFn: (item: T) => R) => R[];
export declare const _findObjectById: <T>(arr: T[], id: string) => T | undefined;
export declare const _getUniqueValues: (arr: any[]) => any[];
export declare const _mergeArraysByKey: (arr1: any, arr2: any, key: string) => any[];
export declare const _removeDuplicates: (arr: any, key: string) => any;
export declare const _groupBy: (arr: any, key: string) => any;
export declare const _arrayDiff: <T>(arr1: T[], arr2: T[]) => T[];
export declare const _deepCompareArrays: <T>(arr1: T[], arr2: T[]) => boolean;
export declare const _updateObjectInArray: (arr: [], key: string, value: any, update: any) => any[];
export declare const _getKeysByValue: (obj: any, value: any) => string[];
export declare const _dateFormat: (date: Date, format?: string) => string;
export declare const _dateTransformer: (data: any) => any;
export declare const _escapeRegExpMatch: (s: string) => string;
export declare const _isExactMatch: (str: string, match: string) => boolean;
export declare const _bytesToSize: (bytes: number, decimals?: number) => string;
export declare const _swapArrayByKey: (arr: any, key: string) => any;
export declare const _setTouchedFields: (formRef: any, errors: any) => void;
export declare const _validateForm: (formRef: any) => Promise<boolean>;
